/******************************************************************/
/*                                                                */
/*   ho|ukahpCN[h     libipvlbi_board_dummy.c     */
/*          Tv[{[hCXg[ĂȂ}V    */
/*          vO`FbNp libipvlbi_board.h        */
/*          ̑ɎgpCN[ht@C                */
/*                                                                */
/*      Version:    2007-08-23                                    */
/*                  2005-12-30  support VSSP32                    */
/*                                                                */
/*      Copyright (c) 2003-2007 T.Kondo/NICT All Right Reserved   */
/*                                                                */
/******************************************************************/
/*
   2004-08-11  start
   2005-06-12  diveded into libipvlbi_board_dummy.h and libipvlbi_board_dummy.c
   2007-02-14  delete functions as follows which are no more use
                    sample_get,sampleget_old, sampleget0, 
                    sampleget2, sampleget3
   2007-02-23  board_ref_check, board_ref_check2, board_time_disp were added
   2007-08-23  dummy function "get_fpga_version" was added.  
*/

//#ifdef WIN32
#include "libipvlbi_board_dummy.h"
//#else
//#include "libipvlbi_board.h"
//#endif

#ifdef WIN32
#include <io.h>
#define read(_Z,_X,_Y) _read(_Z,_X,_Y)
#define write(_Z,_X,_Y) _write(_Z,_X,_Y)
#define open(_Z,_X,_Y) _open(_Z,_X,_Y)
#endif

/********** added on 2007-08-23 ******/

int get_fpga_version(void)
{
/*
   get FPGA version of VSSP32
   
   return 
       Version:   Major*100+Minor
       -1: error
*/

    int fpga_version;
    fpga_version=0;
    return fpga_version;
}

/********** added on 2007-02-23 ******/

int board_time_disp(int secmax)
{
/*  
    Display board time for secmax sec
*/
    int fd_in,rv;
    int day,sec; 
    int secold;
    int  yyyy, mm, dd;   
    int  h, m, s;     
    int  y3; // 7 bits year  (0-127)
    int counter;
    int i;
    float fsec,tofset;


    //fd_in = open(DEV_FILE, O_RDONLY); 
    //if (fd_in == -1) {
    //    perror("device open() error ");
    //    return -1;
    //}
#ifdef _VSSP32
    printf("K5/VSSP32 Sampler Board Time Display\n\n");
#else
    printf("K5/VSSP (IP-VLBI) Board Time Display\n\n");
#endif

    secold=90000;
    counter=0;
    tofset=0.0;

    //get time from device and display while
    do{
        getsystimef(&yyyy, &mm, &dd, &h, &m, &s, &fsec, &tofset);
        md2ddd(yyyy, &day, mm, dd);
        sec=h*3600+m*60+s;
        if (sec!=secold) {
           sec2hms(sec,&h,&m,&s);
           //printf("get count day from device [%5d]\n",TDS_GET_DAYS(time));
           //printf("get count sec from device [%5d]\n",TDS_GET_SEC(time));
#ifdef _VSSP32
           printf("%04d/%03d %02d:%02d:%02d\n\033[A",yyyy,day,h,m,s);
#else
           printf("%03d %02d:%02d:%02d\n\033[A",day,h,m,s);
#endif
           counter++;
       }
       secold=sec;
    }while(counter <=secmax);
    return 0;
}


unsigned int board_ref_check(int fd_in)
{
    /* board reference input signal check */
/*
    [IN}
       fd_in  :  device file directive (must be opened in advance)
    [return]
       reference signal status
*/
    int rv;
    unsigned int stat;
    unsigned int ref, pps, rhz, pll;
    stat=0;
    /* board status check */
    //rv = ioctl(fd_in, TDSIO_GET_STATUS, &stat);
    rv = 0;


    if(rv==-1){
#ifndef _VSSP32
        perror("   ioctl() status get failed ");
#endif
        goto end;
    }
    /* satatus get again just in case */
    //rv = ioctl(fd_in, TDSIO_GET_STATUS, &stat);
    rv = 0;
    if(rv==-1){
#ifndef _VSSP32
        perror("   ioctl() status get failed ");
#endif
        goto end;
    }
    //printf("ioctl() status get succeed\n");
    //printf(" status = %X\n",stat);   // debug
#ifdef _VSSP32
    // separate command
    //stat|=0x8;  // means this is VSSP32
    //ioctl(fd_in, TDSIO_GET_REFINPUT, &ref);
    //if(ref==1) stat|=1;
    //ioctl(fd_in, TDSIO_GET_10MHZINPUT, &rhz);
    //if(rhz==1) stat|=0x4;
    //ioctl(fd_in, TDSIO_GET_1PPSINPUT, &pps);
    //if(pps==1) stat|=0x2;
    
    /* set stat again to keep compatibility with K5/VSSP */
    ref=0; rhz=0; pps=0; pll=0;
    if((stat & 4) == 4) pps=1;        // 1PPS supplied
    if((stat & 8) == 8) ref=1;        // reference signal supplied
    if((stat & 0x20) == 0x20) rhz=1;  // reference signal is 5MHz
    if((stat & 0x10) == 0x10) pll=1;  // PLL locked
    stat=0;
    stat|=0x10;  // means this is VSSP32
    if(ref==1) stat|=1;
    if(pps==1) stat|=0x2;
    if(rhz==1) stat|=0x4;
    if(pll==1) stat|=0x8;
#else
    stat&=3;  // 2005-12-20
#endif
end:
    return stat;
}



/* board reference signal check 2 */
int board_ref_check2(int fd_in)
{
/*
    [IN}
       fd_in  :  device file directive (must be opened in advance)
    [return]
       -1 :  reference signal error
        0 :  OK
*/
    unsigned int stat;

    stat=board_ref_check(fd_in);
    if((stat & 0x10) == 0x10){ // this is VSSP32
        if((stat & 1) != 1){
            printf("   Warning! 10MHz or 5MHz signal is not supplied. \n");
        } else {
            if((stat & 4) == 4){
                printf("   Reference (5MHz) signal is OK!");
            } else {
                printf("   Reference (10MHz) signal is OK!");
            }
            if((stat & 8) == 8){
                printf("   PLL locked!\n");
            } else {
                printf("   Warning! PLL unlocked!\n");
            }
        }
    } else {   // this is VSSP
        if((stat & 1) != 1){
            printf("   Warning! 10MHz signal is not supplied. \n");
        } else {
            printf("   10MHz signal is OK!\n");
        }
    }
    if((stat & 2) != 2){
        printf("   Warning! 1PPS signal is not supplied. \n");
    } else {
        printf("   1PPS  signal is OK!\n");
    }
    if((stat & 3) == 0){
       printf("   Check signal connection and try again!\n");
       return -1;
    }
    if((stat & 3) == 1){
       printf("   Anyway we force to set time!\n");
       return -2;
    }
    return 0;
}
/********   end add */

int check_vssp(int fd_in, unsigned int *stat, int verbose)
{
/*     check reference signals of  K5/VSSP or K5/VSSP32
    [in]
       fd_in  --  device file descripter for K5/VSSP or K5/VSSP32
       verbose --  0: no message out   1: message out
    [return]
        0: OK   
        -1: both ref signal and 1PPS is not supplied or PLL unlocked | get status failed
        -2: only 1PPS is not supplied
        stat ---  detail status 
              bit0 :  reference signal supplied
              bit1 :  1PPS supplied
              bit2 :  reference signal is 5MHz (valid for K5/VSSP32)
              bit3 :  PLL is locked (valid for K5/VSSP32)
              bit4 :  this is K5/VSSP32  (valid for K5/VSSP32)
        
*/
    unsigned int stat0;

    // dummy
    stat0=0;
    *stat=stat0;
    if((stat0 & 0x10) == 0x10){ // this is VSSP32
        if((stat0 & 1) != 1){
            if(verbose==1)
              printf("  check_vssp: Warning! 10MHz or 5MHz signal is not supplied. \n");
        } else {
            if((stat0 & 4) == 4){
                if(verbose==1)
                   printf("  check_vssp: Reference (5MHz) signal is OK!");
            } else {
                if(verbose==1)
                   printf("  check_vssp: Reference (10MHz) signal is OK!");
            }
            if((stat0 & 8) == 8){
                if(verbose==1)
                   printf("  check_vssp: PLL locked!\n");
            } else {
                if(verbose==1)
                   printf("  check_vssp: Warning! PLL unlocked!\n");
                return -1;
            }
        }
    } else {   // this is VSSP
        if((stat0 & 1) != 1){
            if(verbose==1)
               printf("  check_vssp: Warning! 10MHz signal is not supplied. \n");
        } else {
            if(verbose==1)
               printf("  check_vssp: 10MHz signal is OK!\n");
        }
    }
    if((stat0 & 2) != 2){
        if(verbose==1)
           printf("  check_vssp: Warning! 1PPS signal is not supplied. \n");
    } else {
        if(verbose==1)
           printf("  check_vssp: 1PPS  signal is OK!\n");
    }
    if((stat0 & 3) == 0){
    //   printf("  check_vssp:    Check signal connection and try again!\n");
         return -1;
    }
    if((stat0 & 3) == 1){
    //   printf("  check_vssp:    Anyway continue the process!\n");
         return -2;
    }
    return 0;
}

int set_vssp_sparam(int fd_in, vssp_param_t *sp, int verbose)
{
/*     set sampling parameters for K5/VSSP or K5/VSSP32
    [in]
       fd_in  --  device file descripter for K5/VSSP or K5/VSSP32
       sp->sfreq  --  frequency parameter
       sp->adbit  --  AD bits
       sp->numch  --  # of CH
       sp->filter --  filter frequency (MHz) for K5/VSSP32  (0 means through)
       verbose --  0: no message out   1: message out
    [return]
        0: OK   -1: failed
*/
    int rv;
#ifdef _VSSP32
    unsigned int sfreq_u, sbit_u, numch_u, filter_u;  // for K5/VSSP32
#endif
    u_int8_t sampling, sfreq_t, sbit_t, numch_t;      // for K5/VSSP
    
    
    //dummy

#ifdef _VSSP32
    /* sampling frequency set */
    if      (sp->sfreq ==  40)  { sfreq_u =  1; }
    else if (sp->sfreq == 100)  { sfreq_u =  2; }
    else if (sp->sfreq == 200)  { sfreq_u =  3; }
    else if (sp->sfreq == 500)  { sfreq_u =  4; }
    else if (sp->sfreq ==   1)  { sfreq_u =  5; }
    else if (sp->sfreq ==   2)  { sfreq_u =  6; }
    else if (sp->sfreq ==   4)  { sfreq_u =  7; }
    else if (sp->sfreq ==   8)  { sfreq_u =  8; }
    else if (sp->sfreq ==  16)  { sfreq_u =  9; }
    else if (sp->sfreq ==  32)  { sfreq_u = 10; }
    else if (sp->sfreq ==  64)  { sfreq_u = 11; }
    else { 
       //if(verbose==1){
          printf("  set_vssp_sparam: parameter sfreq  (sampling frequency) must be\n");
          printf("                   either one of followings:\n");
          printf("                   40,100,200,500 (for kHz)\n");
          printf("                   1,2,4,8,16,32,64 (for MHz)\n");
       //}
       return -1;
    }
    //rv = ioctl(fd_in, TDSIO_SET_FSAMPLE, &sfreq_u);
    rv=0;
    if (rv != 0) {
       //if(verbose ==1)
          perror("  set_vssp_sparam: ioctl() sampling rate set failed ");
       return -1;
    } else {
       if(verbose ==1)
          printf("  set_vssp_sparam: ioctl() sampling rate set succeed\n");
    }
    /* AD resolution set */
    if      (sp->adbit ==  1)  { sbit_u =  1; }
    else if (sp->adbit ==  2)  { sbit_u =  2; }
    else if (sp->adbit ==  4)  { sbit_u =  3; }
    else if (sp->adbit ==  8)  { sbit_u =  4; }
    else { 
       //if(verbose==1){
           printf("  set_vssp_sparam: parameter adbit (A/D resolution) must be\n");
           printf("                   either one of followings:  1, 2, 4, 8\n");
       //}
       return -1;
    }
    //rv = ioctl(fd_in, TDSIO_SET_RESOLUTIONBIT, &sbit_u);
    rv=0;
    if (rv != 0) {
       //if(verbose ==1)
          perror("  set_vssp_sparam: ioctl() AD resolution set failed ");
       return -1;
    } else {
       if(verbose ==1)
          printf("  set_vssp_sparam: ioctl() AD resolution set suceed\n");
    }
    /* number of channels */
    if      (sp->numch ==  1)  { numch_u =  1; }
    else if (sp->numch ==  4)  { numch_u =  2; }
    else { 
       //if(verbose==1){
          printf("  set_vssp_sparam: parameter numch (number of channels) must be\n");
          printf("                   either one of followings:   1, 4\n");
       //}
       return -1;
    }
    //rv = ioctl(fd_in, TDSIO_SET_CHMODE, &numch_u);
    rv=0;
    if (rv != 0) {
       //if(verbose ==1)
          perror("  set_vssp_sparam: ioctl() channels set failed ");
       return -1;
    } else {
       if(verbose ==1)
          printf("  set_vssp_sparam: ioctl() channels set succeed\n");
    }
    /* filter set */
    //filter_u =  TDSIO_SAMPLING_THRU;
    filter_u =  0;
    if      (sp->filter ==   2)  { filter_u =  1; }
    else if (sp->filter ==   4)  { filter_u =  2; }
    else if (sp->filter ==   8)  { filter_u =  3; }
    else if (sp->filter ==  16)  { filter_u =  4; }
    //rv = ioctl(fd_in, TDSIO_SET_FILTER, &filter_u);
    rv=0;
    if (rv != 0) {
       //if(verbose ==1)
          perror("  set_vssp_sparam: ioctl() filter set failed ");
       return -1;
    } else {
       if(verbose ==1)
          printf("  set_vssp_sparam: ioctl() filter set succeed\n");
    }
#else
    /* sampling frequency set */
    if      (sp->sfreq ==  40)  { sfreq_t =  1; }
    else if (sp->sfreq == 100)  { sfreq_t =  2; }
    else if (sp->sfreq == 200)  { sfreq_t =  3; }
    else if (sp->sfreq == 500)  { sfreq_t =  4; }
    else if (sp->sfreq ==   1)  { sfreq_t =  5; }
    else if (sp->sfreq ==   2)  { sfreq_t =  6; }
    else if (sp->sfreq ==   4)  { sfreq_t =  7; }
    else if (sp->sfreq ==   8)  { sfreq_t =  8; }
    else if (sp->sfreq ==  16)  { sfreq_t =  9; }
    else { 
       //if(verbose==1){
          printf("  set_vssp_sparam: parameter sfreq  (sampling frequency) must be\n");
          printf("                   either one of followings:\n");
          printf("                   40,100,200,500 (for kHz)\n");
          printf("                   1,2,4,8,16 (for MHz)\n");
       //}
       return -1;
    }
      
    /* AD resolution set */
    if      (sp->adbit ==  1)  { sbit_t =  1; }
    else if (sp->adbit ==  2)  { sbit_t =  2; }
    else if (sp->adbit ==  4)  { sbit_t =  3; }
    else if (sp->adbit ==  8)  { sbit_t =  4; }
    else { 
       //if(verbose==1){
           printf("  set_vssp_sparam: parameter adbit (A/D resolution) must be\n");
           printf("                   either one of followings:  1, 2, 4, 8\n");
       //}
       return -1;
    }

    /* number of channels */
    if      (sp->numch ==  1)  { numch_t =  1; }
    else if (sp->numch ==  4)  { numch_t =  2; }
    else { 
       //if(verbose==1){
          printf("  set_vssp_sparam: parameter numch (number of channels) must be\n");
          printf("                   either one of followings:   1, 4\n");
       //}
       return -1;
    }

    /* sampling parameters set */
    
    sampling =  sfreq_t | sbit_t | numch_t;

    //sampling = TDS_SAMPLING_4MHZ | TDS_SAMPLING_1BIT | TDS_SAMPLING_1CH;

    //rv = ioctl(fd_in, TDSIO_SET_SAMPLING, &sampling);
    rv = 0;
    if (rv == -1) {
       //if(verbose==1)
          perror("  set_vssp_sparam: ioctl() sampling set failed ");
       return -1;
    } else {
       if(verbose==1)
          printf("  set_vssp_sparam: ioctl() sampling set succeed\n");
    }
#endif
    return 0;
}


int get_vssp_sparam(int fd_in, vssp_param_t *sp, int verbose)
{
/* get sampling parameters from a board 
    [in]
       fd_in  --  device file descripter for K5/VSSP or K5/VSSP32
       verbose --  0: no message out   1: message out
    [return]
       0: OK   -1: failed
       sp->freqkhz  --  frequency (kHz)
       sp->adbit  --  AD bits
       sp->numch  --  # of CH
       sp->filter --  filter frequency (MHz) for K5/VSSP32  (0 means through)
*/
    int rv;
    unsigned int freq, width, ufilter;
    int ch;
    
    //dummy
    freq=1; ufilter=1; width=1; ch=1;
#ifdef _VSSP32
    /* get sampling frequency */
    //rv = ioctl(fd_in,TDSIO_GET_FSAMPLE,&freq);
    rv=0;
    if(rv  == -1){
        //if(verbose==1)
           perror("  get_vssp_sparam: ioctl() get sampling frequency failed ");
        return -1;
    } else {
        if(freq == 1)  sp->freqkhz = 40;
        else if(freq == 2) sp->freqkhz = 100;
        else if(freq == 3) sp->freqkhz = 200;
        else if(freq == 4) sp->freqkhz = 500;
        else if(freq == 5)   sp->freqkhz = 1000;
        else if(freq == 6)   sp->freqkhz = 2000;
        else if(freq == 7)   sp->freqkhz = 4000;
        else if(freq == 8)   sp->freqkhz = 8000;
        else if(freq == 9)  sp->freqkhz = 16000;
        else if(freq == 10)  sp->freqkhz = 32000;
        else if(freq == 11)  sp->freqkhz = 64000;
    }
    /* get filter frequency */
    //rv = ioctl(fd_in,TDSIO_GET_FILTER,&ufilter)
    rv=0;
    if(rv  == -1){
        //if(verbose==1)
           perror("  get_vssp_sparam: ioctl() get filter parameter failed ");
        return -1;
    } else {
        if(ufilter == 1)  sp->filter = 2;
        else if(ufilter == 2)  sp->filter = 4;
        else if(ufilter == 3)  sp->filter = 8;
        else if(ufilter == 4)  sp->filter = 16;
        else if(ufilter == 5)  sp->filter = 0;
    }
    /* get AD resolution bit */
    //rv = ioctl(fd_in,TDSIO_GET_RESOLUTIONBIT,&width);
    rv=0;
    if(rv == -1){
        //if(verbose==1)
           perror("  get_vssp_sparam: ioctl() get AD resolution failed ");
        return -1;
    } else {
        if(width == 1)  sp->adbit = 1;
        else if(width == 2)  sp->adbit = 2;
        else if(width == 3)  sp->adbit = 4;
        else if(width == 4)  sp->adbit = 8;
    }
    /* get # of CH */
    //rv = ioctl(fd_in,TDSIO_GET_CHMODE,&ch);
    rv=0;
    if(rv == -1){
        //if(verbose==1)
           perror("  get_vssp_sparam: ioctl() get # of CH failed ");
        return -1;
    } else {
        if(ch == 1)  sp->numch = 1;
        else if(ch == 2)  sp->numch = 4;
    }
    
#else
    rv=0;
    sp->filter=0;
    if (rv == -1) {
        //if(verbose==1)
           perror("  get_vssp_sparam: ioctl() get sampling parameter failed ");
        return -1;
    }

    //rv = ioctl(fd_in,TDSIO_GET_SAMPLING,&sampling1);
    rv=0;
    if (rv == -1) {
        //if(verbose==1)
           perror("  get_vssp_sparam: ioctl() get sampling parameter failed ");
        return -1;
    }
    else {
        if(verbose==1)
           printf("  get_vssp_sparam: ioctl() get sampling parameter succeed\n");
        //freq = TDS_GET_SAMP_FREQ(sampling1);
        //width = TDS_GET_SAMP_WIDTH(sampling1);
        //ch = TDS_GET_SAMP_CH(sampling1);
        if(freq == 1)  sp->freqkhz = 40;
        if(freq == 2) sp->freqkhz = 100;
        if(freq == 3) sp->freqkhz = 200;
        if(freq == 4) sp->freqkhz = 500;
        if(freq == 5)   sp->freqkhz = 1000;
        if(freq == 6)   sp->freqkhz = 2000;
        if(freq == 7)   sp->freqkhz = 4000;
        if(freq == 8)   sp->freqkhz = 8000;
        if(freq == 9)  sp->freqkhz = 16000;
        if(width == 1)  sp->adbit = 1;
        if(width == 2)  sp->adbit = 2;
        if(width == 3)  sp->adbit = 4;
        if(width == 4)  sp->adbit = 8;
        if(ch == 2){
            sp->numch = 4;
        } else {
            sp->numch =1;
        }
    }   
#endif
    return 0;
}

int vssp_wait_nsec(int fd_in, int nsec)
{
/*
    wait N seconds using VSSP board data
    (dummy is get time from PC)
*/
    unsigned int sec; 
    unsigned int seco;
    int ns;
    int hh,mm,ss,month,mday,year;  // 2007-02-13
    float fsec,tofset;             // 2007-02-13

    seco=-99;
    ns=-1;
    /* board time get */
    // dumyy
    tofset=0.0;
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset); 
    seco=hh*3600+mm*60+ss;
    
 loop:
 
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset); 
    sec=hh*3600+mm*60+ss;

    if(sec != seco) {
       seco=sec;
       ns++;
       if(ns == nsec) goto exithere;
    }
    goto loop;
 exithere:
    return 0;
}



/* Tv[{[h */
//int ini_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec)
int ini_sampler(int *fd_in, vssp_param_t *sp, int *bitsec)
{
    unsigned int freq;
    
    printf("ini_sampler_dummy : ioctl() sampling set succeed\n");
    freq=sp->sfreq;
    if(freq < 40) freq*=1000;
    printf("ini_sampler_dummy : sampling setting is %d kHz %d BIT %d CH",freq,sp->adbit,sp->numch);
#ifdef _VSSP32
    printf("FILTR %dMHz\n",sp->filter);
#endif
    printf("\n");
    return 0;
}


/* TvOX^[g */
int start_sampler(int *fd_in)
{
    //int rv;
       
     printf("start_sampler_dummy : ioctl() start sampling succeed\n");
    return 0;
}


/* TvOXgbv */
int stop_sampler(int *fd_in)
{
    printf("stop_sampler_dummy : ioctl() stop sampling succeed\n");

       
    return 0;
}


/* Tv[{[hуf[^WgK[ */
//int ini_and_start_sampler(int *fd_in,int sfreq, int adbit, int numch, long int *bitsec)
int ini_and_start_sampler(int *fd_in, vssp_param_t *sp, int *bitsec)
{
    int rv;

    //rv=ini_sampler(&(*fd_in),sfreq, adbit, numch, &(*bitsec));
    rv=ini_sampler(fd_in, sp, bitsec);

    rv=start_sampler(fd_in);
    
    return rv;
}


/*  f[^W֐
   NۂɃf[^W܂łRbII

  []
    spg->outfile ---- f[^o̓t@C
    spg->span    ---- f[^Wԁ@ibj
    spg->sfreq   ---- TvOg
                    40,100,200,500 (for kHz)
                    1,2,4,8,16 (for MHz)
    spg->adbit   ---- `crbg
                    1,2,4,8
    spg->numch   ---- `l
                    1, 4
    spg->f_size_mode ---- 0: 2GBȏ̃t@CT|[g
                          1: 2GB̃t@C쐬
    spg->lg.logdir --- Ot@CfBNg
    spg->lg.hostname -- zXg
    spg->lg.logfile ---Ot@C
    spg->lg.logfiletype -- Ot@C
                          0: exocode+station_id+"."+hostname+".log"
                          1: YYYY+hostname+".log"
                               where  YYYY is 4 digit year
                          -1: Oo͗}
    2002-10-21 2Gbytesȏ̊ϑ悤ɕύX
    2004-05-23 Oo͋@\ǉ
*/


int sampleget(spget_t *spg)
{
    //char dev[] = "/dev/tds0";
    char dev[] = "dummy.dat";  // dummy data file
    //int fd_in;
    //int fd_out;
    //mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
    int k;
    int headbit;  // header bit number
    //int headbit=64;  // header bit number  for a new sampler board
    //int headbit=32;  // header bit number  for a old sampler board
    long int allbyte;     // TvOoCg
    long int bitsec;       // Pb̃rbg@iwb_[USrbg܂ށj
    long int bytesec;       // Pb̃oCg@iwb_[USrbg܂ށj
    long int c;
    int sfreq, adbit, numch, span;
    int filter;
#ifdef _VSSP32  // just for the case of VSSP32 only
    int auxsize;
#endif
    int nbyte;
    char outfile[120];
    unsigned int freq;
    // 2002-10-21
    double dallbyte, dc;
    int f_c;   // file number counter  in case of file exceeds > 2Gbyte
    char cbuf[160];
    char outname2[120]; // for extra output
    // ----------
    //u_int8_t sfreq_t, sbit_t, numch_t;
    //u_int8_t sampling;
    //u_int32_t buf[BUFSIZ * 2];
    logval_t lg;
    unsigned long int buf[BUFSIZ * 2];
    //printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ1024łI

    headbit=64;  // header bit number  for K5/VSSP
    span=spg->span;
    sfreq=spg->sp.sfreq;
    adbit=spg->sp.adbit;
    numch=spg->sp.numch;
    filter=spg->sp.filter;
    strcpy(outfile,spg->outfile);
    lg=spg->lg;
    
    /*
    printf(" span = %d\n",span);    // debug
    printf(" sfreq= %d\n",sfreq);   // debug
    printf(" adbit= %d\n",adbit);   // debug
    printf(" numch= %d\n",numch);   // debug
    */
    
    /* sampling duration check */
    if (span <= 0) {
        printf(" parameter span (duration in sec) should be positive!\n");
        // nothing to do
        return -1;
    }
        
    /* sampler open */
    //fd_in = fopen(dev, "rb");
    //fd_in = open("/dev/tds0", O_RDONLY);
    //if (fd_in == -1) {
    //    perror("device open() error ");
    //   return -1;
    //}
    
    /* output file open */
    //fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
    //if (fd_out == -1) {
    //    perror("output file open() error");
    //    goto end;
    //}
#ifdef _VSSP32  // just for the case of VSSP32 only
    /* set AUX field data */
    if(spg->sp.vsspaux.size > 0) {    // default size should be 20
        auxsize=spg->sp.vsspaux.size;
    } else {
        auxsize=20;
    }
    headbit=64+32+8*auxsize;   // header bit calc
    if(headbit != 256){
        printf("  sampleget:Warning!! header bits (%d) is different from default value (256)\n",headbit);
    } else {
        printf("  sampleget: header bits = %d\n",headbit);
    }
#endif    
   
    /* sampling parameters set */
    
    //sampling =  sfreq_t | sbit_t | numch_t;
    
    if (sfreq == 40 || sfreq == 100 || sfreq == 200 || sfreq == 500 ) {     //2005-12-21
        bitsec=sfreq*1000 ;
    } else { 
        bitsec=sfreq*1000*1000;
    }
    
    //bitsec=bitsec*adbit*numch;   // bit number per second
    bitsec=(bitsec*adbit*numch)+headbit;   // bit number per second  !! 2002-9-15
    
    bytesec=bitsec/8;
    allbyte=bytesec*span;
    dallbyte=(double)bytesec*(double)span;   // 2002-10-21
    
    /* File maximum bytes check */
    printf(" bitsec  = %d\n",bitsec);  // debug
    printf(" bytesec = %d\n",bytesec);  // debug
    //printf(" allbyte = %d\n",allbyte);  // debug
    printf(" allbyte = %g\n",dallbyte);  // debug
    
    freq=sfreq;
    if(freq < 40) freq*=1000;
    printf("sampling setting is %d kHz %d BIT %d CH",freq,adbit,numch);
#ifdef _VSSP32
    printf(" FILTR %d MHz",filter);
#endif
    printf("\n");
        
    printf("ioctl()_dummy FIFO clear succeed\n");
    
    /* sampling start */
    
    printf("ioctl()_dummy start sampling succeed\n");
    printf("This is version (2005-12-30) of sampleget (dummy)\n");
    LogWrite4(&lg,0,0.0,1,"sampleget error test");
    c = 0;
    dc= 0.0;   // 2002-10-21
    f_c=0;    // 2002-10-21
    //while (c <=  allbyte) {
    nbyte = sizeof(buf)/sizeof(unsigned long int);   // 
    printf("debug nbyte %d\n",nbyte);
	goto exithere; // bypass  2009-11-19
    while (1) {                   // 2002-10-21

        // random data generation instead of reading sampled data 
        //  from IP-VLBI board
        for (k=0; k<nbyte; k++){
             buf[k]=(unsigned int)rand();
        }
        //rv = read(fd_in, buf, nbyte);
        //if (rv == -1) {
        //    perror("read() failed ");
        //    goto end;
        //}
        //printf(" nbyte = %d\n",nbyte);   // debug
        
        //rv = write(fd_out, buf, rv);
        c+= nbyte;
        /* add on 2002-10-21 */
        dc+=(double)nbyte;
        //printf(" dc %f   dallbyte %f\n",dc,dallbyte);   // debug

        if( dc > dallbyte) {   // sampling end
            goto exithere;
        }
        if(spg->f_size_mode==1 && c >  FILEMAXSIZE) { // newfile creation
            c=0;
            //close(fd_out);
            f_c++;
            // new file name creation     XXXX.datN   where N=1,2,3......
            strcpy(outname2,outfile);
            sprintf(cbuf,"%d\0",f_c);
            strcat(outname2,cbuf);
            printf("outfile %d %s\n",f_c,outname2);  //debug
            /* output file open */
            //fd_out = open(outname2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
            //if (fd_out == -1) {
            //    perror("output file open() error");
            //    goto end;
            //}
        }
        
    }
    
exithere:

    printf("debug span %d\n",span);

    tk_sleep((span+1)*1000);  // above process doesn't consume time
                              // so to simulate actual scan span 
                              // sleep  span*1000 msec here
    /* sampling stop */
    
    printf("ioctl()_dummy stop sampling succeed\n");
    
    //close(fd_out);
    
//end:
    //close(fd_in);
    
    return 0;
}
        

//int sampleget4(char* outfile, int span, int sfreq, int adbit, int numch, char* dirtemp, int mode)
int sampleget4(spget_t *spg, int mode)
{
/*      sampleget3 ̉ǔ  (₦VNp^[̌osj

                mode    -- t@Co̓[h
                       1: ꊇt@Ĉ iftHgj
                       2: Pbf[^t@Ĉ
                       3:  ꊇt@C{Pbƃt@C
                       4:  Pbf[^t@CóAϑꊇt@C쐬
                       5:  3+4  for debug purpose ꊇt@C debug.dat 쐬
                       6: Pbf[^t@Ĉ (Ԑj
                       7: UƓit@Co͖jVXe`FbNp
*/
    //Dummy
    int rv;
    rv=0;
    return rv;
}
        
int ip_board_time(unsigned int *day, unsigned int *sec, int *hh, int *mm, int *ss)
{
     int year,month,mday,ddd;
       float fsec, tofset ;

       tofset=0.0;
   
     //foCX玞̎擾̑ɃVXe玞擾
      getsystimef(&year, &month, &mday, hh, mm, ss, &fsec, &tofset);
       *sec=(*hh)*3600+(*mm)*60+(*ss);
       md2ddd(year, &ddd, month, mday);
       *day=ddd;
    return 0;
}

int toffset_get(int *yearPC, float *tofset) 
// get time difference between IP-BOARD time and PC time   2003-08-21
{ 
    int year,month,mday,hh,mm,ss;
    float fsec;
    //foCX玞̎擾 and display while
    *tofset=0.0;
    
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, tofset);
    printf("System Time : %04d/%02d/%02d %02d:%02d:%02d\n",year,month,mday,hh,mm,ss);
    printf("Offset (dummy) %f\n",*tofset);
    *yearPC=year;  // save year info get from PC
    //printf("yearPC  %d\n",*yearPC);
    return 0;   
}
    
int LogWrite2(char* logdir, char* hostname, int time_mode, 
              float secofset, int mode, char* cbuf)
{
/*
  [in]
     logdir  -----  logfile directory
     hostname ----  host PC name
     time_mode ---  0: time get from PC
                    1: time get from IP-VLBI board
     mode   ------  logfile separator mode
                    0:  : 
                    1:  /
                    2:  "
                    3:  ?
                    4:  #
                    5:  (space)
     cbuf           log statement
 
  ---------
       logfilename  logdir/YYYYhostname.log

       TIME(UT) get from host
       log format
            YYDDDHHMMSSXY cbuf
    where    YY   -- year (2 digits)
             DDD  -- total day  (day of year)
             HH   -- hour
             MM   -- minute
             SS   -- sec
             X    -- separator mode
             Y    -- time_mode   (space) for IP-Board Time
                                  p  for PC-TIME
             cbuf -- Any comment
    
       A logfile will be opened as an append mode every time.

*/
    int i,ilen,ddd,y1,y2,imode;
    int hh,mm,ss,month,mday,year;
    unsigned int day, secnow;
    float fsec,tofset;
    int ip[7];
    char logfile[90], wbuf[30];
    char septab[][2]={":","/","\"","?","#"," "};
    FILE* flog;
    //time_t tnow;              // for getting date and time info
    //struct tm tmnow;          //        "

    // current time get
    tofset=secofset;
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
    secnow=hh*3600+mm*60+ss;
    md2ddd(year, &ddd, month, mday);
    if(time_mode == 1) {
       if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) return -1 ;
       ddd=day;
       ddd2md(year, ddd, &month, &mday);
    }           

    ip[0]=year;
    ip[1]=ddd;
    ip[2]=hh;
    ip[3]=mm;
    ip[4]=ss;
    ip[5]=month;
    ip[6]=mday;
    y1=ip[0] % 10;
    y2=ip[0] % 100;
    //printf("CURRENT TIME(UT) %s\n", asctime(&tmnow)); //debug
    //for (i=0; i<7; i++) printf("%d ",ip[i]); printf("\n"); //debug

    /* logfilename create */
    strcpy(logfile,logdir);
    ilen=strlen(logfile);
    if (logfile[ilen-1] != '/'){
        logfile[ilen]='/';
        logfile[ilen+1]='\0';
    }
    sprintf(wbuf,"%04d%s.log\0",year,hostname);
    strcat(logfile,wbuf);
    if( (flog  = fopen( logfile, "a" )) == NULL ){
        printf("LogWrite: Log File (%s) Open Error! \n",logfile);
        return -1;
    }
    //printf("LogWrite: Log File (%s) Opened! \n",logfile);  // debug
    
    imode=mode;
    if(imode <0 || imode >5) imode=5;
    if(time_mode==1){
       sprintf(wbuf,"%02d%03d%02d%02d%02d%s  \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    } else {
       sprintf(wbuf,"%02d%03d%02d%02d%02d%sp \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    }
    fprintf(flog,"%s%s\n",wbuf,cbuf);
    i=fclose(flog);
    return 0;
}
    
void LogWrite3(char* logdir, char* hostname, char* logfile, int logfiletype,
              int time_mode,  float secofset, int mode, char* cbuf)
{
/*
  [in]
     logdir  -----  logfile directory
     hostname ----  host PC name
     logfile  -----  logfile name
     logfiletype --  logfile name definitiion
                      0: logfile
                      1: logdir/YYYY+hostname+".log"
                         where  YYYY is 4 digit year
     time_mode ---  0: time get from PC
                    1: time get from IP-VLBI board
     mode   ------  logfile separator mode
                    0:  : 
                    1:  /
                    2:  "
                    3:  ?
                    4:  #
                    5:  (space)
     cbuf           log statement
 
  ---------

       TIME(UT) get from host
       log format
            YYDDDHHMMSSXY cbuf
    where    YY   -- year (2 digits)
             DDD  -- total day  (day of year)
             HH   -- hour
             MM   -- minute
             SS   -- sec
             X    -- separator mode
             Y    -- time_mode   (space) for IP-Board Time
                                  p  for PC-TIME
             cbuf -- Any comment
    
       A logfile will be opened as an append mode every time.

*/
    int i,ilen,ddd,y1,y2,imode;
    int hh,mm,ss,month,mday,year;
    unsigned int day, secnow;
    float fsec,tofset;
    int ip[7];
    char wbuf[30];
    char septab[][2]={":","/","\"","?","#"," "};
    FILE* flog;
    //time_t tnow;              // for getting date and time info
    //struct tm tmnow;          //        "
    if(logfiletype < 0) goto exit_end;  // nothing to do
    // current time get
    tofset=secofset;
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
    secnow=hh*3600+mm*60+ss;
    md2ddd(year, &ddd, month, mday);
    if(time_mode == 1) {
        if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) {
           printf("LogWrite3: IP-BOARD TIME GET ERROR! \n");
           goto exit_end;
        }
       ddd=day;
       ddd2md(year, ddd, &month, &mday);
    }           

    ip[0]=year;
    ip[1]=ddd;
    ip[2]=hh;
    ip[3]=mm;
    ip[4]=ss;
    ip[5]=month;
    ip[6]=mday;
    y1=ip[0] % 10;
    y2=ip[0] % 100;
    //printf("CURRENT TIME(UT) %s\n", asctime(&tmnow)); //debug
    //for (i=0; i<7; i++) printf("%d ",ip[i]); printf("\n"); //debug

    /* logfilename create */
    if(logfiletype==1){
       strcpy(logfile,logdir);
       ilen=strlen(logfile);
       if (logfile[ilen-1] != '/'){
           logfile[ilen]='/';
           logfile[ilen+1]='\0';
       } 
       sprintf(wbuf,"%04d%s.log\0",year,hostname);
       strcat(logfile,wbuf);
    }

    /* logfile open */
    if( (flog  = fopen( logfile, "a" )) == NULL ){
        printf("LogWrite3: Log File (%s) Open Error! \n",logfile);
        goto exit_end;
    }
    //printf("LogWrite: Log File (%s) Opened! \n",logfile);  // debug
    
    imode=mode;
    if(imode <0 || imode >5) imode=5;
    if(time_mode==1){
       sprintf(wbuf,"%02d%03d%02d%02d%02d%s  \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    } else {
       sprintf(wbuf,"%02d%03d%02d%02d%02d%sp \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    }
    fprintf(flog,"%s%s\n",wbuf,cbuf);
    i=fclose(flog);
exit_end:;

}

    
void LogWrite4(logval_t *lg, int time_mode,  float secofset, int mode, char* cbuf)
{
/*
  [in]
     log->logdir  -----  logfile directory
     log->hostname ----  host PC name
     log->logfile  -----  logfile name
     log->logfiletype --  logfile name definitiion
                      0: logfile
                      1: logdir/YYYY+hostname+".log"
                         where  YYYY is 4 digit year
                     -1:  no log
     time_mode ---  0: time get from PC
                    1: time get from IP-VLBI board
     mode   ------  logfile separator mode
                    0:  : 
                    1:  /
                    2:  "
                    3:  ?
                    4:  #
                    5:  (space)
     cbuf           log statement
 
  ---------

       TIME(UT) get from host
       log format
            YYDDDHHMMSSXY cbuf
    where    YY   -- year (2 digits)
             DDD  -- total day  (day of year)
             HH   -- hour
             MM   -- minute
             SS   -- sec
             X    -- separator mode
             Y    -- time_mode   (space) for IP-Board Time
                                  p  for PC-TIME
             cbuf -- Any comment
    
       A logfile will be opened as an append mode every time.

*/
    int i,ilen,ddd,y1,y2,imode;
    int hh,mm,ss,month,mday,year;
    unsigned int day, secnow;
    float fsec,tofset;
    int ip[7];
    char wbuf[30];
    char septab[][2]={":","/","\"","?","#"," "};
    FILE* flog;
    //time_t tnow;              // for getting date and time info
    //struct tm tmnow;          //        "
    if(lg->logfiletype < 0) goto exit_end;  // nothing to do
    // current time get
    tofset=secofset;
    getsystimef(&year, &month, &mday, &hh, &mm, &ss, &fsec, &tofset);
    secnow=hh*3600+mm*60+ss;
    md2ddd(year, &ddd, month, mday);
    if(time_mode == 1) {
        if(ip_board_time(&day, &secnow, &hh, &mm, &ss)==-1) {
           printf("LogWrite4: IP-BOARD TIME GET ERROR! \n");
           goto exit_end;
        }
       ddd=day;
       ddd2md(year, ddd, &month, &mday);
    }           

    ip[0]=year;
    ip[1]=ddd;
    ip[2]=hh;
    ip[3]=mm;
    ip[4]=ss;
    ip[5]=month;
    ip[6]=mday;
    y1=ip[0] % 10;
    y2=ip[0] % 100;
    //printf("CURRENT TIME(UT) %s\n", asctime(&tmnow)); //debug
    //for (i=0; i<7; i++) printf("%d ",ip[i]); printf("\n"); //debug

    /* logfilename create */
    if(lg->logfiletype==1){
       strcpy(lg->logfile,lg->logdir);
       ilen=strlen(lg->logfile);
       if (lg->logfile[ilen-1] != '/'){
           lg->logfile[ilen]='/';
           lg->logfile[ilen+1]='\0';
       } 
       sprintf(wbuf,"%04d%s.log\0",year,lg->hostname);
       strcat(lg->logfile,wbuf);
    }

    /* logfile open */
    if( (flog  = fopen( lg->logfile, "a" )) == NULL ){
        printf("LogWrite4: Log File (%s) Open Error! \n",lg->logfile);
        goto exit_end;
    }
    //printf("LogWrite: Log File (%s) Opened! \n",logfile);  // debug
    
    imode=mode;
    if(imode <0 || imode >5) imode=5;
    if(time_mode==1){
       sprintf(wbuf,"%02d%03d%02d%02d%02d%s  \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    } else {
       sprintf(wbuf,"%02d%03d%02d%02d%02d%sp \0",y2,ddd,ip[2],ip[3],ip[4],septab[imode]);
    }
    fprintf(flog,"%s%s\n",wbuf,cbuf);
    i=fclose(flog);
exit_end:;

}
